"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bootstrap = bootstrap;
exports.die = die;
exports.dieSync = dieSync;
Object.defineProperty(exports, "bootstrapHook", {
  enumerable: true,
  get: function get() {
    return _bootstrap2.default;
  }
});
Object.defineProperty(exports, "BootstrapParams", {
  enumerable: true,
  get: function get() {
    return _bootstrap2.Params;
  }
});
Object.defineProperty(exports, "initHook", {
  enumerable: true,
  get: function get() {
    return _init.default;
  }
});
Object.defineProperty(exports, "InitParams", {
  enumerable: true,
  get: function get() {
    return _init.Params;
  }
});
Object.defineProperty(exports, "deathHook", {
  enumerable: true,
  get: function get() {
    return _death.default;
  }
});
Object.defineProperty(exports, "DeathParams", {
  enumerable: true,
  get: function get() {
    return _death.Params;
  }
});
exports.log = void 0;

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.promise");

require("regenerator-runtime/runtime");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _logger = require("@spine/logger");

var _bootstrap2 = _interopRequireWildcard(require("./hooks/bootstrap"));

var _init = _interopRequireWildcard(require("./hooks/init"));

var _death = _interopRequireWildcard(require("./hooks/death"));

var log = (0, _logger.logger)('bootstrap');
exports.log = log;

var destroy = function destroy(async) {
  log.verbose('Shutting down...');
  return _death.default.do({
    async: async
  });
};

var bootstrapping = false;

function bootstrap(_x) {
  return _bootstrap.apply(this, arguments);
}

function _bootstrap() {
  _bootstrap = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(config) {
    var extra,
        bootstrap,
        init,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            extra = _args.length > 1 && _args[1] !== undefined ? _args[1] : null;

            if (!bootstrapping) {
              _context.next = 3;
              break;
            }

            throw new Error('Bootstrap has already started');

          case 3:
            bootstrapping = true;
            log.verbose('Registering hooks...');
            _context.next = 7;
            return _bootstrap2.default.do((0, _objectSpread2.default)({}, extra, {
              config: config
            }));

          case 7:
            bootstrap = _context.sent;
            log.verbose('Initializing...');
            _context.next = 11;
            return _init.default.do({});

          case 11:
            init = _context.sent;
            return _context.abrupt("return", {
              bootstrap: bootstrap,
              init: init
            });

          case 13:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _bootstrap.apply(this, arguments);
}

function die() {
  return _die.apply(this, arguments);
}

function _die() {
  _die = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    var result, keys, values, _key;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            result = destroy(true);
            keys = [];
            values = [];

            for (_key in result) {
              keys.push(_key);
              values.push(Promise.resolve(result[_key]));
            }

            _context2.next = 6;
            return Promise.all(values).then(function (resolved) {
              var obj = {};
              resolved.forEach(function (value, index) {
                obj[keys[index]] = value;
              });
              return obj;
            });

          case 6:
            return _context2.abrupt("return", _context2.sent);

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return _die.apply(this, arguments);
}

function dieSync() {
  return destroy(false);
}
//# sourceMappingURL=index.js.map